define("activesync/folder", [ "rdcommon/log", "../date", "../syncbase", "../db/mail_rep", "activesync/codepages/AirSync", "activesync/codepages/AirSyncBase", "activesync/codepages/ItemEstimate", "activesync/codepages/Email", "activesync/codepages/ItemOperations", "safe-base64", "mimetypes", "module", "require", "exports" ], function(e, t, n, o, r, s, i, a, c, u, l, d, h, p) {
    function f() {
        y = r.Enums.FilterType, v = {
            auto: null,
            "1d": y.OneDayBack,
            "3d": y.ThreeDaysBack,
            "1w": y.OneWeekBack,
            "2w": y.TwoWeeksBack,
            "1m": y.OneMonthBack,
            all: y.NoFilter
        }, b = {
            0: "all messages",
            1: "one day",
            2: "three days",
            3: "one week",
            4: "two weeks",
            5: "one month"
        };
    }
    function g(e, t, n) {
        return function() {
            var o = Array.slice(arguments), r = o[e], s = this;
            h([ "wbxml", "addressparser", "../mailchew" ], function(e, i, a) {
                S || (S = e, T = i.parse.bind(i), w = a, f()), s._account.withConnection(r, function() {
                    t.apply(s, o);
                }, n);
            });
        };
    }
    function m(e, t, n) {
        this._account = e, this._storage = t, this._LOG = C.ActiveSyncFolderConn(this, n, t.folderId), 
        this.folderMeta = t.folderMeta, this.syncKey || (this.syncKey = "0");
    }
    function _(e, t, n) {
        this._account = e, this.folderStorage = t, this._LOG = C.ActiveSyncFolderSyncer(this, n, t.folderId), 
        this.folderConn = new m(e, t, this._LOG);
    }
    var y, v, b, S, T, w, E = 512, A = 50;
    m.prototype = {
        get syncKey() {
            return this.folderMeta.syncKey;
        },
        set syncKey(e) {
            return this.folderMeta.syncKey = e;
        },
        get serverId() {
            return this.folderMeta.serverId;
        },
        get filterType() {
            var e = this._account.accountDef.syncRange;
            if (v.hasOwnProperty(e)) {
                var t = v[e];
                return t ? t : this.folderMeta.filterType;
            }
            return console.warn("Got an invalid syncRange (" + e + ") using three days back instead"), 
            r.Enums.FilterType.ThreeDaysBack;
        },
        _getSyncKey: g(1, function(e, t) {
            var n = this, o = this._account, s = r.Tags, i = new S.Writer("1.3", 1, "UTF-8");
            i.stag(s.Sync).stag(s.Collections).stag(s.Collection), o.conn.currentVersion.lt("12.1") && i.tag(s.Class, "Email"), 
            i.tag(s.SyncKey, "0").tag(s.CollectionId, this.serverId).stag(s.Options).tag(s.FilterType, e).etag().etag().etag().etag(), 
            o.conn.postCommand(i, function(e, r) {
                if (e) return console.error(e), o._reportErrorIfNecessary(e), t("unknown"), void 0;
                n.syncKey = "0";
                var i = new S.EventParser();
                i.addEventListener([ s.Sync, s.Collections, s.Collection, s.SyncKey ], function(e) {
                    n.syncKey = e.children[0].textContent;
                }), i.onerror = function() {}, i.run(r), "0" === n.syncKey ? (console.error("Unable to get sync key for folder"), 
                t("unknown")) : t();
            });
        }),
        _getItemEstimate: g(1, function(e, t) {
            var n = i.Tags, o = r.Tags, s = this._account, a = new S.Writer("1.3", 1, "UTF-8");
            a.stag(n.GetItemEstimate).stag(n.Collections).stag(n.Collection), this._account.conn.currentVersion.gte("14.0") ? a.tag(o.SyncKey, this.syncKey).tag(n.CollectionId, this.serverId).stag(o.Options).tag(o.FilterType, e).etag() : this._account.conn.currentVersion.gte("12.0") ? a.tag(n.CollectionId, this.serverId).tag(o.FilterType, e).tag(o.SyncKey, this.syncKey) : a.tag(n.Class, "Email").tag(o.SyncKey, this.syncKey).tag(n.CollectionId, this.serverId).tag(o.FilterType, e), 
            a.etag(n.Collection).etag(n.Collections).etag(n.GetItemEstimate), s.conn.postCommand(a, function(e, o) {
                if (e) return console.error(e), s._reportErrorIfNecessary(e), t("unknown"), void 0;
                var r, a, c = new S.EventParser(), u = [ n.GetItemEstimate, n.Response ];
                c.addEventListener(u.concat(n.Status), function(e) {
                    r = e.children[0].textContent;
                }), c.addEventListener(u.concat(n.Collection, n.Estimate), function(e) {
                    a = parseInt(e.children[0].textContent, 10);
                });
                try {
                    c.run(o);
                } catch (l) {
                    return console.error("Error parsing GetItemEstimate response", l, "\n", l.stack), 
                    t("unknown"), void 0;
                }
                r !== i.Enums.Status.Success ? (console.error("Error getting item estimate:", r), 
                t("unknown")) : t(null, a);
            });
        }),
        _inferFilterType: g(0, function(e) {
            var t = this, n = r.Enums.FilterType, o = function(o, r) {
                t._getSyncKey(o, function(s) {
                    return s ? (e("unknown"), void 0) : (t._getItemEstimate(o, function(t, o) {
                        return t ? (e(null, n.ThreeDaysBack), void 0) : (r(o), void 0);
                    }), void 0);
                });
            };
            o(n.TwoWeeksBack, function(r) {
                var s, i = r / 14;
                if (0 > r) s = n.ThreeDaysBack; else if (i >= A) s = n.OneDayBack; else if (3 * i >= A) s = n.ThreeDaysBack; else if (7 * i >= A) s = n.OneWeekBack; else if (14 * i >= A) s = n.TwoWeeksBack; else {
                    if (!(30 * i >= A)) return o(n.NoFilter, function(o) {
                        var r;
                        o > A ? (r = n.OneMonthBack, t.syncKey = "0") : r = n.NoFilter, t._LOG.inferFilterType(r), 
                        e(null, r);
                    }), void 0;
                    s = n.OneMonthBack;
                }
                s !== n.TwoWeeksBack && (t.syncKey = "0"), t._LOG.inferFilterType(s), e(null, s);
            });
        }),
        _enumerateFolderChanges: g(0, function(e, t) {
            var n = this, o = this._storage;
            if (!this.filterType) return this._inferFilterType(function(o, r) {
                return o ? (e("unknown"), void 0) : (console.log("We want a filter of", b[r]), n.folderMeta.filterType = r, 
                n._enumerateFolderChanges(e, t), void 0);
            }), void 0;
            if ("0" === this.syncKey) return this._getSyncKey(this.filterType, function(o) {
                return o ? (e("aborted"), void 0) : (n._enumerateFolderChanges(e, t), void 0);
            }), void 0;
            var i = r.Tags, a = r.Enums;
            s.Tags, s.Enums;
            var c;
            0 === this._account._syncsInProgress++ && this._account._lastSyncKey === this.syncKey && this._account._lastSyncFilterType === this.filterType && this._account._lastSyncResponseWasEmpty ? c = i.Sync : (c = new S.Writer("1.3", 1, "UTF-8"), 
            c.stag(i.Sync).stag(i.Collections).stag(i.Collection), this._account.conn.currentVersion.lt("12.1") && c.tag(i.Class, "Email"), 
            c.tag(i.SyncKey, this.syncKey).tag(i.CollectionId, this.serverId).tag(i.GetChanges).stag(i.Options).tag(i.FilterType, this.filterType), 
            this._account.conn.currentVersion.lte("12.0") && c.tag(i.MIMESupport, a.MIMESupport.Never).tag(i.Truncation, a.MIMETruncation.TruncateAll), 
            c.etag().etag().etag().etag()), this._account.conn.postCommand(c, function(r, s) {
                var c, u = [], l = [], d = [], h = !1;
                if (n._account._syncsInProgress--, r) return console.error("Error syncing folder:", r), 
                n._account._reportErrorIfNecessary(r), e("aborted"), void 0;
                if (n._account._lastSyncKey = n.syncKey, n._account._lastSyncFilterType = n.filterType, 
                !s) return console.log("Sync completed with empty response"), n._account._lastSyncResponseWasEmpty = !0, 
                e(null, u, l, d), void 0;
                n._account._lastSyncResponseWasEmpty = !1;
                var p = new S.EventParser(), f = [ i.Sync, i.Collections, i.Collection ];
                p.addEventListener(f.concat(i.SyncKey), function(e) {
                    n.syncKey = e.children[0].textContent;
                }), p.addEventListener(f.concat(i.Status), function(e) {
                    c = e.children[0].textContent;
                }), p.addEventListener(f.concat(i.MoreAvailable), function() {
                    h = !0;
                }), p.addEventListener(f.concat(i.Commands, [ [ i.Add, i.Change ] ]), function(e) {
                    var t, r;
                    for (var s in Iterator(e.children)) {
                        var a = s[1];
                        switch (a.tag) {
                          case i.ServerId:
                            t = a.children[0].textContent;
                            break;

                          case i.ApplicationData:
                            try {
                                r = n._parseMessage(a, e.tag === i.Add, o);
                            } catch (c) {
                                return console.error("Failed to parse a message:", c, "\n", c.stack), void 0;
                            }
                        }
                    }
                    r.header.srvid = t;
                    var d = e.tag === i.Add ? u : l;
                    d.push(r);
                }), p.addEventListener(f.concat(i.Commands, [ [ i.Delete, i.SoftDelete ] ]), function(e) {
                    var t;
                    for (var n in Iterator(e.children)) {
                        var o = n[1];
                        switch (o.tag) {
                          case i.ServerId:
                            t = o.children[0].textContent;
                        }
                    }
                    d.push(t);
                });
                try {
                    p.run(s);
                } catch (g) {
                    return console.error("Error parsing Sync response:", g, "\n", g.stack), e("unknown"), 
                    void 0;
                }
                c === a.Status.Success ? (console.log("Sync completed: added " + u.length + ", changed " + l.length + ", deleted " + d.length), 
                e(null, u, l, d, h), h && n._enumerateFolderChanges(e, t)) : c === a.Status.InvalidSyncKey ? (console.warn("ActiveSync had a bad sync key"), 
                e("badkey")) : (console.error("Something went wrong during ActiveSync syncing and we got a status of " + c), 
                e("unknown"));
            }, null, null, function(e, n) {
                n || (n = Math.max(1e6, e)), t(.1 + .7 * e / n);
            });
        }, "aborted"),
        _parseMessage: function(e, t, n) {
            var r, i, c, u = a.Tags, d = s.Tags, h = s.Enums;
            if (t) {
                var p = n._issueNewHeaderId();
                r = {
                    id: p,
                    srvid: null,
                    suid: n.folderId + "/" + p,
                    guid: "",
                    author: null,
                    to: null,
                    cc: null,
                    bcc: null,
                    replyTo: null,
                    date: null,
                    flags: [],
                    hasAttachments: !1,
                    subject: null,
                    snippet: null
                }, i = {
                    date: null,
                    size: 0,
                    attachments: [],
                    relatedParts: [],
                    references: null,
                    bodyReps: null
                }, c = function(e, t) {
                    t && r.flags.push(e);
                };
            } else r = {
                flags: [],
                mergeInto: function(e) {
                    for (var t in Iterator(this.flags)) {
                        var n = t[1];
                        if (n[1]) e.flags.push(n[0]); else {
                            var o = e.flags.indexOf(n[0]);
                            -1 !== o && e.flags.splice(o, 1);
                        }
                    }
                    var r = [ "mergeInto", "suid", "srvid", "guid", "id", "flags" ];
                    for (var t in Iterator(this)) {
                        var s = t[0], i = t[1];
                        -1 === r.indexOf(s) && (e[s] = i);
                    }
                }
            }, i = {
                mergeInto: function(e) {
                    for (var t in Iterator(this)) {
                        var n = t[0], o = t[1];
                        "mergeInto" !== n && (e[n] = o);
                    }
                }
            }, c = function(e, t) {
                r.flags.push([ e, t ]);
            };
            var f, g;
            for (var m in Iterator(e.children)) {
                var _ = m[1], y = _.children.length ? _.children[0].textContent : null;
                switch (_.tag) {
                  case u.Subject:
                    r.subject = y;
                    break;

                  case u.From:
                    r.author = T(y)[0] || null;
                    break;

                  case u.To:
                    r.to = T(y);
                    break;

                  case u.Cc:
                    r.cc = T(y);
                    break;

                  case u.ReplyTo:
                    r.replyTo = T(y);
                    break;

                  case u.DateReceived:
                    i.date = r.date = new Date(y).valueOf();
                    break;

                  case u.Read:
                    c("\\Seen", "1" === y);
                    break;

                  case u.Flag:
                    for (var v in Iterator(_.children)) {
                        var b = v[1];
                        b.tag === u.Status && c("\\Flagged", "0" !== b.children[0].textContent);
                    }
                    break;

                  case d.Body:
                    for (var v in Iterator(_.children)) {
                        var b = v[1];
                        switch (b.tag) {
                          case d.Type:
                            var S = b.children[0].textContent;
                            S === h.Type.HTML ? f = "html" : (S !== h.Type.PlainText && console.warn("A message had a strange body type:", S), 
                            f = "plain");
                            break;

                          case d.EstimatedDataSize:
                            g = b.children[0].textContent;
                        }
                    }
                    break;

                  case u.BodySize:
                    f = "plain", g = y;
                    break;

                  case d.Attachments:
                  case u.Attachments:
                    for (var v in Iterator(_.children)) {
                        var w = v[1];
                        if (w.tag === d.Attachment || w.tag === u.Attachment) {
                            var E = {
                                name: null,
                                contentId: null,
                                type: null,
                                part: null,
                                encoding: null,
                                sizeEstimate: null,
                                file: null
                            }, A = !1;
                            for (var C in Iterator(w.children)) {
                                var I, O, x = C[1], D = x.children.length ? x.children[0].textContent : null;
                                switch (x.tag) {
                                  case d.DisplayName:
                                  case u.DisplayName:
                                    E.name = D, I = E.name.lastIndexOf("."), O = I > 0 ? E.name.substring(I + 1).toLowerCase() : "", 
                                    E.type = l.detectMimeType(O);
                                    break;

                                  case d.FileReference:
                                  case u.AttName:
                                    E.part = D;
                                    break;

                                  case d.EstimatedDataSize:
                                  case u.AttSize:
                                    E.sizeEstimate = parseInt(D, 10);
                                    break;

                                  case d.ContentId:
                                    E.contentId = D;
                                    break;

                                  case d.IsInline:
                                    A = "1" === D;
                                    break;

                                  case d.FileReference:
                                  case u.Att0Id:
                                    E.part = x.children[0].textContent;
                                }
                            }
                            A ? i.relatedParts.push(o.makeAttachmentPart(E)) : i.attachments.push(o.makeAttachmentPart(E));
                        }
                    }
                    r.hasAttachments = i.attachments.length > 0;
                }
            }
            return t ? (i.bodyReps = [ o.makeBodyPart({
                type: f,
                sizeEstimate: g,
                amountDownloaded: 0,
                isDownloaded: !1
            }) ], {
                header: o.makeHeaderInfo(r),
                body: o.makeBodyInfo(i)
            }) : {
                header: r,
                body: i
            };
        },
        downloadBodies: function(e, t, n) {
            function o(e) {
                e && !r && (r = e), --s || a._storage.runAfterDeferredCalls(function() {
                    n(r, i - s);
                });
            }
            if (this._account.conn.currentVersion.lt("12.0")) return this._syncBodies(e, n);
            for (var r, s = 1, i = 0, a = this, c = 0; c < e.length; c++) e[c] && null === e[c].snippet && (s++, 
            i++, this.downloadBodyReps(e[c], t, o));
            window.setZeroTimeout(o);
        },
        downloadBodyReps: g(1, function(e, t, n) {
            var o = this, i = this._account;
            if (i.conn.currentVersion.lt("12.0")) return this._syncBodies([ e ], n);
            "function" == typeof t && (n = t, t = null), t = t || {};
            var a = c.Tags, u = c.Enums, l = r.Tags;
            r.Enums;
            var d = s.Tags, h = s.Enums.Type, p = function(r) {
                if (!r) return n("unknown");
                var s, c = r.bodyReps[0], p = "html" === c.type ? h.HTML : h.PlainText;
                t.maximumBytesToFetch < c.sizeEstimate && (p = h.PlainText, s = E);
                var f = new S.Writer("1.3", 1, "UTF-8");
                f.stag(a.ItemOperations).stag(a.Fetch).tag(a.Store, "Mailbox").tag(l.CollectionId, o.serverId).tag(l.ServerId, e.srvid).stag(a.Options).stag(a.Schema).tag(d.Body).etag().stag(d.BodyPreference).tag(d.Type, p), 
                s && f.tag(d.TruncationSize, s), f.etag().etag().etag().etag(), i.conn.postCommand(f, function(t, c) {
                    if (t) return console.error(t), i._reportErrorIfNecessary(t), n("unknown"), void 0;
                    var l, h, p = new S.EventParser();
                    p.addEventListener([ a.ItemOperations, a.Status ], function(e) {
                        l = e.children[0].textContent;
                    }), p.addEventListener([ a.ItemOperations, a.Response, a.Fetch, a.Properties, d.Body, d.Data ], function(e) {
                        h = e.children[0].textContent;
                    });
                    try {
                        p.run(c);
                    } catch (f) {
                        return n("unknown");
                    }
                    return l !== u.Status.Success ? n("unknown") : (o._updateBody(e, r, h, !!s, n), 
                    void 0);
                });
            };
            this._storage.getMessageBody(e.suid, e.date, p);
        }),
        _syncBodies: function(e, t) {
            var n = r.Tags, o = r.Enums, s = a.Tags, i = this, c = this._account, u = new S.Writer("1.3", 1, "UTF-8");
            u.stag(n.Sync).stag(n.Collections).stag(n.Collection).tag(n.Class, "Email").tag(n.SyncKey, this.syncKey).tag(n.CollectionId, this.serverId).stag(n.Options).tag(n.MIMESupport, o.MIMESupport.Never).etag().stag(n.Commands);
            for (var l = 0; l < e.length; l++) u.stag(n.Fetch).tag(n.ServerId, e[l].srvid).etag();
            u.etag().etag().etag().etag(), c.conn.postCommand(u, function(r, a) {
                function u(e) {
                    e && !d && (d = e), --p || i._storage.runAfterDeferredCalls(function() {
                        t(d);
                    });
                }
                if (r) return console.error(r), c._reportErrorIfNecessary(r), t("unknown"), void 0;
                var l, d, h = 0, p = 1, f = new S.EventParser(), g = [ n.Sync, n.Collections, n.Collection ];
                return f.addEventListener(g.concat(n.SyncKey), function(e) {
                    i.syncKey = e.children[0].textContent;
                }), f.addEventListener(g.concat(n.Status), function(e) {
                    l = e.children[0].textContent;
                }), f.addEventListener(g.concat(n.Responses, n.Fetch, n.ApplicationData, s.Body), function(t) {
                    var n = e[h++], o = t.children[0].textContent;
                    p++, i._storage.getMessageBody(n.suid, n.date, function(e) {
                        i._updateBody(n, e, o, !1, u);
                    });
                }), f.run(a), l !== o.Status.Success ? u("unknown") : (u(null), void 0);
            });
        },
        _activeSyncHeaderIsSeen: function(e) {
            for (var t = 0; t < e.flags.length; t++) if ("\\Seen" === e.flags[t][0] && e.flags[t][1]) return !0;
            return !1;
        },
        _updateBody: function(e, t, n, o, r) {
            var s = t.bodyReps[0];
            n = n.replace(/\r/g, "");
            var i = o ? "plain" : s.type, a = w.processMessageContent(n, i, !o, !0, this._LOG);
            e.snippet = a.snippet, s.isDownloaded = !o, s.amountDownloaded = n.length, o || (s.content = a.content);
            var c = {
                changeDetails: {
                    bodyReps: [ 0 ]
                }
            };
            this._storage.updateMessageHeader(e.date, e.id, !1, e, t), this._storage.updateMessageBody(e, t, {}, c), 
            this._storage.runAfterDeferredCalls(r.bind(null, null, t));
        },
        sync: g(1, function(e, t, o) {
            var r = this, s = 0, i = 0, a = 0;
            this._LOG.sync_begin(null, null, null);
            var c = this;
            this._enumerateFolderChanges(function(o, u, l, d, h) {
                var p = r._storage;
                if ("badkey" === o) return r._account._recreateFolder(p.folderId, function() {
                    r._storage = null, r._LOG.sync_end(null, null, null);
                }), void 0;
                if (o) return r._LOG.sync_end(null, null, null), t(o), void 0;
                for (var f in Iterator(u)) {
                    var g = f[1];
                    p.hasMessageWithServerId(g.header.srvid) || (p.addMessageHeader(g.header, g.body), 
                    p.addMessageBody(g.header, g.body), s++);
                }
                for (var f in Iterator(l)) {
                    var g = f[1];
                    p.hasMessageWithServerId(g.header.srvid) && (p.updateMessageHeaderByServerId(g.header.srvid, !0, function(e, t) {
                        return !c._activeSyncHeaderIsSeen(t) && c._activeSyncHeaderIsSeen(e.header) ? p.folderMeta.unreadCount-- : c._activeSyncHeaderIsSeen(t) && !c._activeSyncHeaderIsSeen(e.header) && p.folderMeta.unreadCount++, 
                        e.header.mergeInto(t), !0;
                    }.bind(null, g), null), i++);
                }
                for (var f in Iterator(d)) {
                    var m = f[1];
                    p.hasMessageWithServerId(m) && (p.deleteMessageByServerId(m), a++);
                }
                if (!h) {
                    var _ = s + i + a;
                    p.runAfterDeferredCalls(function() {
                        r._LOG.sync_end(s, i, a), p.markSyncRange(n.OLDEST_SYNC_DATE, e, "XXX", e), t(null, null, _);
                    });
                }
            }, o);
        }),
        performMutation: g(1, function(e, t) {
            var n = this, o = r.Tags, s = this._account, i = new S.Writer("1.3", 1, "UTF-8");
            i.stag(o.Sync).stag(o.Collections).stag(o.Collection), s.conn.currentVersion.lt("12.1") && i.tag(o.Class, "Email"), 
            i.tag(o.SyncKey, this.syncKey).tag(o.CollectionId, this.serverId).tag(o.DeletesAsMoves, "trash" === this.folderMeta.type ? "0" : "1").tag(o.GetChanges, "0").stag(o.Commands);
            try {
                e(i);
            } catch (a) {
                return console.error("Exception in performMutation callee:", a, "\n", a.stack), 
                t("unknown"), void 0;
            }
            i.etag(o.Commands).etag(o.Collection).etag(o.Collections).etag(o.Sync), s.conn.postCommand(i, function(e, i) {
                if (e) return console.error("postCommand error:", e), s._reportErrorIfNecessary(e), 
                t("unknown"), void 0;
                var a, c, u = new S.EventParser(), l = [ o.Sync, o.Collections, o.Collection ];
                u.addEventListener(l.concat(o.SyncKey), function(e) {
                    a = e.children[0].textContent;
                }), u.addEventListener(l.concat(o.Status), function(e) {
                    c = e.children[0].textContent;
                });
                try {
                    u.run(i);
                } catch (d) {
                    return console.error("Error parsing Sync response:", d, "\n", d.stack), t("unknown"), 
                    void 0;
                }
                c === r.Enums.Status.Success ? (n.syncKey = a, t && t(null)) : (console.error("Something went wrong during ActiveSync syncing and we got a status of " + c), 
                t("status:" + c));
            });
        }),
        downloadMessageAttachments: g(2, function(e, t, n) {
            var o = this, r = c.Tags, i = c.Enums.Status, a = s.Tags, l = new S.Writer("1.3", 1, "UTF-8");
            l.stag(r.ItemOperations);
            for (var d in Iterator(t)) {
                var h = d[1];
                l.stag(r.Fetch).tag(r.Store, "Mailbox").tag(a.FileReference, h.part).etag();
            }
            l.etag(), this._account.conn.postCommand(l, function(e, s) {
                if (e) return console.error("postCommand error:", e), o._account._reportErrorIfNecessary(e), 
                n("unknown"), void 0;
                var c, l = {}, d = new S.EventParser();
                d.addEventListener([ r.ItemOperations, r.Status ], function(e) {
                    c = e.children[0].textContent;
                }), d.addEventListener([ r.ItemOperations, r.Response, r.Fetch ], function(e) {
                    var t = null, n = {};
                    for (var o in Iterator(e.children)) {
                        var s = o[1];
                        switch (s.tag) {
                          case r.Status:
                            n.status = s.children[0].textContent;
                            break;

                          case a.FileReference:
                            t = s.children[0].textContent;
                            break;

                          case r.Properties:
                            var i = null, c = null;
                            for (var d in Iterator(s.children)) {
                                var h = d[1], p = h.children[0].textContent;
                                switch (h.tag) {
                                  case a.ContentType:
                                    i = p;
                                    break;

                                  case r.Data:
                                    c = u.decode(p);
                                }
                            }
                            i && c && (n.data = new Blob([ c ], {
                                type: i
                            }));
                        }
                        t && (l[t] = n);
                    }
                }), d.run(s);
                var h = c !== i.Success ? "unknown" : null, p = [];
                for (var f in Iterator(t)) {
                    var g = f[1];
                    l.hasOwnProperty(g.part) && l[g.part].status === i.Success ? p.push(l[g.part].data) : (h = "unknown", 
                    p.push(null));
                }
                n(h, p);
            });
        })
    }, p.ActiveSyncFolderSyncer = _, _.prototype = {
        get syncable() {
            return null !== this.folderConn.serverId;
        },
        get canGrowSync() {
            return !1;
        },
        initialSync: function(e, n, o, r, s) {
            o("sync", !0), this.folderConn.sync(t.NOW(), this.onSyncCompleted.bind(this, r, !0), s);
        },
        refreshSync: function(e, n, o, r, s, i, a) {
            this.folderConn.sync(t.NOW(), this.onSyncCompleted.bind(this, i, !1), a);
        },
        growSync: function() {
            return !1;
        },
        onSyncCompleted: function(e, t, o, r, s) {
            var i = this.folderStorage;
            console.log("Sync Completed!", s, "messages synced"), o || i.markSyncedToDawnOfTime(), 
            this._account.__checkpointSyncCompleted(function() {
                o ? e(o) : t ? (i._curSyncSlice.ignoreHeaders = !1, i._curSyncSlice.waitingOnData = "db", 
                i.getMessagesInImapDateRange(0, null, n.INITIAL_FILL_SIZE, n.INITIAL_FILL_SIZE, i.onFetchDBHeaders.bind(i, i._curSyncSlice, !1, e, null))) : e(o);
            });
        },
        allConsumersDead: function() {},
        shutdown: function() {
            this.folderConn.shutdown(), this._LOG.__die();
        }
    };
    var C = p.LOGFAB = e.register(d, {
        ActiveSyncFolderConn: {
            type: e.CONNECTION,
            subtype: e.CLIENT,
            events: {
                inferFilterType: {
                    filterType: !1
                }
            },
            asyncJobs: {
                sync: {
                    newMessages: !0,
                    changedMessages: !0,
                    deletedMessages: !0
                }
            },
            errors: {
                htmlParseError: {
                    ex: e.EXCEPTION
                },
                htmlSnippetError: {
                    ex: e.EXCEPTION
                },
                textChewError: {
                    ex: e.EXCEPTION
                },
                textSnippetError: {
                    ex: e.EXCEPTION
                }
            }
        },
        ActiveSyncFolderSyncer: {
            type: e.DATABASE,
            events: {}
        }
    });
}), define("activesync/jobs", [ "rdcommon/log", "mix", "../jobmixins", "../drafts/jobs", "activesync/codepages/AirSync", "activesync/codepages/Email", "activesync/codepages/Move", "module", "require", "exports" ], function(e, t, n, o, r, s, i, a, c, u) {
    function l(e, t, n) {
        return function() {
            var o = Array.slice(arguments), r = o[e], s = this;
            c([ "wbxml" ], function(e) {
                h || (h = e), s.account.withConnection(r, function() {
                    t.apply(s, o);
                }, n);
            });
        };
    }
    function d(e, t, n) {
        this.account = e, this.resilientServerIds = !0, this._heldMutexReleasers = [], this._LOG = p.ActiveSyncJobDriver(this, n, this.account.id), 
        this._state = t, t.hasOwnProperty("suidToServerId") || (t.suidToServerId = {}, t.moveMap = {}), 
        this._stateDelta = {
            serverIdMap: null,
            moveMap: null
        };
    }
    var h;
    u.ActiveSyncJobDriver = d, d.prototype = {
        postJobCleanup: n.postJobCleanup,
        allJobsDone: n.allJobsDone,
        _accessFolderForMutation: function(e, t, n, o, r) {
            var s = this.account.getFolderStorageForFolderId(e), i = this;
            s.runMutexed(r, function(e) {
                i._heldMutexReleasers.push(e);
                var o = s.folderSyncer;
                if (t) i.account.withConnection(n, function() {
                    try {
                        n(o.folderConn, s);
                    } catch (e) {
                        i._LOG.callbackErr(e);
                    }
                }); else try {
                    n(o.folderConn, s);
                } catch (r) {
                    i._LOG.callbackErr(r);
                }
            });
        },
        _partitionAndAccessFoldersSequentially: n._partitionAndAccessFoldersSequentially,
        local_do_modtags: n.local_do_modtags,
        do_modtags: l(1, function(e, t, n) {
            function o(e) {
                return i && -1 !== i.indexOf(e) ? !0 : a && -1 !== a.indexOf(e) ? !1 : void 0;
            }
            var i = n ? e.removeTags : e.addTags, a = n ? e.addTags : e.removeTags, c = o("\\Seen"), u = o("\\Flagged"), l = r.Tags, d = s.Tags, h = null;
            this._partitionAndAccessFoldersSequentially(e.messages, !0, function(e, t, n, o, r) {
                return n = n.filter(function(e) {
                    return !!e;
                }), n.length ? (e.performMutation(function(e) {
                    for (var t = 0; t < n.length; t++) e.stag(l.Change).tag(l.ServerId, n[t]).stag(l.ApplicationData), 
                    void 0 !== c && e.tag(d.Read, c ? "1" : "0"), void 0 !== u && e.stag(d.Flag).tag(d.Status, u ? "2" : "0").etag(), 
                    e.etag(l.ApplicationData).etag(l.Change);
                }, function(e) {
                    e && (h = e), r();
                }), void 0) : (r(), void 0);
            }, function() {
                t(h);
            }, function() {
                h = "aborted-retry";
            }, n, "modtags");
        }),
        check_modtags: function(e, t) {
            t(null, "idempotent");
        },
        local_undo_modtags: n.local_undo_modtags,
        undo_modtags: function(e, t) {
            this.do_modtags(e, t, !0);
        },
        local_do_move: n.local_do_move,
        do_move: l(1, function(e, t) {
            var n = null, o = this.account, r = this.account.getFolderStorageForFolderId(e.targetFolder), s = i.Tags;
            this._partitionAndAccessFoldersSequentially(e.messages, !0, function(e, t, i, a, c) {
                if (i = i.filter(function(e) {
                    return !!e;
                }), !i.length) return c(), void 0;
                if (i = i.filter(function(e) {
                    return !!e;
                }), !i.length) return c(), void 0;
                var u = new h.Writer("1.3", 1, "UTF-8");
                u.stag(s.MoveItems);
                for (var l = 0; l < i.length; l++) u.stag(s.Move).tag(s.SrcMsgId, i[l]).tag(s.SrcFldId, t.folderMeta.serverId).tag(s.DstFldId, r.folderMeta.serverId).etag(s.Move);
                u.etag(s.MoveItems), o.conn.postCommand(u, function(e) {
                    e && (n = e, console.error("failure moving messages:", e)), c();
                });
            }, function() {
                t(n, null, !0);
            }, function() {
                n = "aborted-retry";
            }, !1, "move");
        }),
        check_move: function() {},
        local_undo_move: n.local_undo_move,
        undo_move: function() {},
        local_do_delete: n.local_do_delete,
        do_delete: l(1, function(e, t) {
            var n = null, o = r.Tags;
            s.Tags, this._partitionAndAccessFoldersSequentially(e.messages, !0, function(e, t, r, s, i) {
                return r = r.filter(function(e) {
                    return !!e;
                }), r.length ? (e.performMutation(function(e) {
                    for (var t = 0; t < r.length; t++) e.stag(o.Delete).tag(o.ServerId, r[t]).etag(o.Delete);
                }, function(e) {
                    e && (n = e, console.error("failure deleting messages:", e)), i();
                }), void 0) : (i(), void 0);
            }, function() {
                t(n, null, !0);
            }, function() {
                n = "aborted-retry";
            }, !1, "delete");
        }),
        check_delete: function(e, t) {
            t(null, "idempotent");
        },
        local_undo_delete: n.local_undo_delete,
        undo_delete: function(e, t) {
            t("moot");
        },
        local_do_syncFolderList: function(e, t) {
            t(null);
        },
        do_syncFolderList: l(1, function(e, t) {
            var n, o = this.account, r = o.getFirstFolderWithType("inbox");
            r && null === r.serverId && (n = o.getFolderStorageForFolderId(r.id)), o.syncFolderList(function(e) {
                e || (o.meta.lastFolderSyncAt = Date.now()), t(e ? "aborted-retry" : null, null, !e), 
                n && n.hasActiveSlices && (e || (console.log("Refreshing fake inbox"), n.resetAndRefreshActiveSlices()));
            });
        }, "aborted-retry"),
        check_syncFolderList: function(e, t) {
            t("idempotent");
        },
        local_undo_syncFolderList: function(e, t) {
            t("moot");
        },
        undo_syncFolderList: function(e, t) {
            t("moot");
        },
        local_do_downloadBodies: n.local_do_downloadBodies,
        do_downloadBodies: n.do_downloadBodies,
        check_downloadBodies: n.check_downloadBodies,
        local_do_downloadBodyReps: n.local_do_downloadBodyReps,
        do_downloadBodyReps: n.do_downloadBodyReps,
        check_downloadBodyReps: n.check_downloadBodyReps,
        local_do_download: n.local_do_download,
        do_download: n.do_download,
        check_download: n.check_download,
        local_undo_download: n.local_undo_download,
        undo_download: n.undo_download,
        local_do_sendOutboxMessages: n.local_do_sendOutboxMessages,
        do_sendOutboxMessages: n.do_sendOutboxMessages,
        check_sendOutboxMessages: n.check_sendOutboxMessages,
        local_undo_sendOutboxMessages: n.local_undo_sendOutboxMessages,
        undo_sendOutboxMessages: n.undo_sendOutboxMessages,
        local_do_setOutboxSyncEnabled: n.local_do_setOutboxSyncEnabled,
        local_do_upgradeDB: n.local_do_upgradeDB,
        local_do_purgeExcessMessages: function(e, t) {
            t(null);
        },
        do_purgeExcessMessages: function(e, t) {
            t(null);
        },
        check_purgeExcessMessages: function() {
            return "idempotent";
        },
        local_undo_purgeExcessMessages: function(e, t) {
            t(null);
        },
        undo_purgeExcessMessages: function(e, t) {
            t(null);
        }
    }, t(d.prototype, o.draftsMixins);
    var p = u.LOGFAB = e.register(a, {
        ActiveSyncJobDriver: {
            type: e.DAEMON,
            events: {
                savedAttachment: {
                    storage: !0,
                    mimeType: !0,
                    size: !0
                },
                saveFailure: {
                    storage: !1,
                    mimeType: !1,
                    error: !1
                }
            },
            TEST_ONLY_events: {
                saveFailure: {
                    filename: !1
                }
            },
            errors: {
                callbackErr: {
                    ex: e.EXCEPTION
                }
            }
        }
    });
}), define("activesync/account", [ "rdcommon/log", "../a64", "../accountmixins", "../mailslice", "../searchfilter", "activesync/codepages/FolderHierarchy", "./folder", "./jobs", "../util", "../db/folder_info_rep", "module", "require", "exports" ], function(e, t, n, o, r, s, i, a, c, u, l, d, h) {
    function p(e, t, n) {
        return function() {
            var o = Array.slice(arguments), r = o[e], s = this;
            this.withConnection(r, function() {
                t.apply(s, o);
            }, n);
        };
    }
    function f(e, t, r, s, c, u) {
        this.universe = e, this.id = t.id, this.accountDef = t, t.connInfo.deviceId || (t.connInfo.deviceId = h.makeUniqueDeviceId()), 
        this._db = s, this._LOG = S.ActiveSyncAccount(this, u, this.id), c ? (this.conn = c, 
        this._attachLoggerToConnection(this.conn)) : this.conn = null, this.enabled = !0, 
        this.problems = [], this._alive = !0, this.identities = t.identities, this.folders = [], 
        this._folderStorages = {}, this._folderInfos = r, this._serverIdToFolderId = {}, 
        this._deadFolderIds = null, this._syncsInProgress = 0, this._lastSyncKey = null, 
        this._lastSyncResponseWasEmpty = !1, this.meta = r.$meta, this.mutations = r.$mutations, 
        this.tzOffset = 0;
        for (var l in r) if ("$" !== l[0]) {
            var d = r[l];
            this._folderStorages[l] = new o.FolderStorage(this, l, d, this._db, i.ActiveSyncFolderSyncer, this._LOG), 
            this._serverIdToFolderId[d.$meta.serverId] = l, this.folders.push(d.$meta);
        }
        this.folders.sort(function(e, t) {
            return e.path.localeCompare(t.path);
        }), this._jobDriver = new a.ActiveSyncJobDriver(this, this._folderInfos.$mutationState), 
        this.ensureEssentialOfflineFolders(), n.accountConstructorMixin.call(this, this, this);
    }
    var g, m, _, y = c.bsearchForInsert, v = s.Enums.Type, b = h.DEFAULT_TIMEOUT_MS = 3e4;
    h.makeUniqueDeviceId = function() {
        return Math.random().toString(36).substr(2);
    }, h.Account = h.ActiveSyncAccount = f, f.prototype = {
        type: "activesync",
        supportsServerFolders: !0,
        toString: function() {
            return "[ActiveSyncAccount: " + this.id + "]";
        },
        withConnection: function(e, t, n) {
            if (!g) return d([ "wbxml", "activesync/protocol", "activesync/codepages" ], function(o, r, s) {
                g = o, m = r, _ = s, this.withConnection(e, t, n);
            }.bind(this)), void 0;
            if (!this.conn) {
                var o = this.accountDef;
                this.conn = new m.Connection(o.connInfo.deviceId), this._attachLoggerToConnection(this.conn), 
                this.conn.open(o.connInfo.server, o.credentials.username, o.credentials.password), 
                this.conn.timeout = b;
            }
            this.conn.connected ? t() : this.conn.connect(function(o) {
                return o ? (this._reportErrorIfNecessary(o), this._isBadUserOrPassError(o) && !n && (n = "bad-user-or-pass"), 
                e(n || "unknown"), void 0) : (t(), void 0);
            }.bind(this));
        },
        _isBadUserOrPassError: function(e) {
            return e && e instanceof m.HttpError && 401 === e.status;
        },
        _reportErrorIfNecessary: function(e) {
            e && this._isBadUserOrPassError(e) && this.universe.__reportAccountProblem(this, "bad-user-or-pass", "incoming");
        },
        _attachLoggerToConnection: function(e) {
            var t = S.ActiveSyncConnection(e, this._LOG, Date.now() % 1e3);
            "safe" === t.logLevel ? e.onmessage = this._onmessage_safe.bind(this, t) : "dangerous" === t.logLevel && (e.onmessage = this._onmessage_dangerous.bind(this, t));
        },
        _onmessage_safe: function(e, t, n, o, r, s, i, a) {
            "options" === t ? e.options(n, o.status, a) : e.command(t, n, o.status);
        },
        _onmessage_dangerous: function(e, t, n, o, r, s, i, a) {
            if ("options" === t) e.options(n, o.status, a); else {
                var c, u;
                if (i) try {
                    var l = new g.Reader(new Uint8Array(i), _);
                    c = l.dump();
                } catch (d) {
                    c = "parse problem";
                }
                if (a) try {
                    u = a.dump(), a.rewind();
                } catch (d) {
                    u = "parse problem";
                }
                e.command(t, n, o.status, r, s, c, u);
            }
        },
        toBridgeWire: function() {
            return {
                id: this.accountDef.id,
                name: this.accountDef.name,
                path: this.accountDef.name,
                type: this.accountDef.type,
                defaultPriority: this.accountDef.defaultPriority,
                enabled: this.enabled,
                problems: this.problems,
                syncRange: this.accountDef.syncRange,
                syncInterval: this.accountDef.syncInterval,
                notifyOnNew: this.accountDef.notifyOnNew,
                playSoundOnSend: this.accountDef.playSoundOnSend,
                identities: this.identities,
                credentials: {
                    username: this.accountDef.credentials.username
                },
                servers: [ {
                    type: this.accountDef.type,
                    connInfo: this.accountDef.connInfo
                } ]
            };
        },
        toBridgeFolder: function() {
            return {
                id: this.accountDef.id,
                name: this.accountDef.name,
                path: this.accountDef.name,
                type: "account"
            };
        },
        get numActiveConns() {
            return 0;
        },
        checkAccount: function(e) {
            null != this.conn && (this.conn.connected && this.conn.disconnect(), this.conn = null), 
            this.withConnection(function(t) {
                e(t);
            }, function() {
                e();
            });
        },
        __checkpointSyncCompleted: function(e, t) {
            this.saveAccountState(null, e, t || "checkpointSync");
        },
        shutdown: function(e) {
            this._LOG.__die(), e && e();
        },
        accountDeleted: function() {
            this._alive = !1, this.shutdown();
        },
        sliceFolderMessages: function(e, t) {
            var n = this._folderStorages[e], r = new o.MailSlice(t, n, this._LOG);
            n.sliceOpenMostRecent(r);
        },
        searchFolderMessages: function(e, t, n, o) {
            var s = this._folderStorages[e], i = new r.SearchSlice(t, s, n, o, this._LOG);
            return s.sliceOpenSearch(i), i;
        },
        syncFolderList: p(0, function(e) {
            var t = this, n = _.FolderHierarchy.Tags, o = new g.Writer("1.3", 1, "UTF-8");
            o.stag(n.FolderSync).tag(n.SyncKey, this.meta.syncKey).etag(), this.conn.postCommand(o, function(o, r) {
                if (o) return t._reportErrorIfNecessary(o), e(o), void 0;
                var s = new g.EventParser(), i = [];
                s.addEventListener([ n.FolderSync, n.SyncKey ], function(e) {
                    t.meta.syncKey = e.children[0].textContent;
                }), s.addEventListener([ n.FolderSync, n.Changes, [ n.Add, n.Delete ] ], function(e) {
                    var o = {};
                    for (var r in Iterator(e.children)) {
                        var s = r[1];
                        o[s.localTagName] = s.children[0].textContent;
                    }
                    e.tag === n.Add ? t._addedFolder(o.ServerId, o.ParentId, o.DisplayName, o.Type) || i.push(o) : t._deletedFolder(o.ServerId);
                });
                try {
                    s.run(r);
                } catch (a) {
                    return console.error("Error parsing FolderSync response:", a, "\n", a.stack), e("unknown"), 
                    void 0;
                }
                for (;i.length; ) {
                    var c = [];
                    for (var u in Iterator(i)) {
                        var l = u[1];
                        t._addedFolder(l.ServerId, l.ParentId, l.DisplayName, l.Type) || c.push(l);
                    }
                    if (c.length === i.length) throw new Error("got some orphaned folders");
                    i = c;
                }
                t.ensureEssentialOnlineFolders(), t.normalizeFolderHierarchy(), console.log("Synced folder list"), 
                e && e(null);
            });
        }),
        _folderTypes: {
            1: "normal",
            2: "inbox",
            3: "drafts",
            4: "trash",
            5: "sent",
            6: "normal",
            12: "normal"
        },
        _addedFolder: function(e, n, r, s, a, c) {
            if (!(a || s in this._folderTypes)) return !0;
            var l = r, d = null, h = 0;
            if ("0" !== n) {
                if (d = this._serverIdToFolderId[n], void 0 === d) return null;
                var p = this._folderInfos[d];
                l = p.$meta.path + "/" + l, h = p.$meta.depth + 1;
            }
            if (s === v.DefaultInbox) {
                var f = this.getFirstFolderWithType("inbox");
                if (f) return delete this._serverIdToFolderId[f.serverId], this._serverIdToFolderId[e] = f.id, 
                f.serverId = e, f.name = r, f.path = l, f.depth = h, f;
            }
            var g = this.id + "/" + t.encodeInt(this.meta.nextFolderNum++), m = this._folderInfos[g] = {
                $meta: u.makeFolderMeta({
                    id: g,
                    serverId: e,
                    name: r,
                    type: a || this._folderTypes[s],
                    path: l,
                    parentId: d,
                    depth: h,
                    lastSyncedAt: 0,
                    syncKey: "0",
                    version: o.FOLDER_DB_VERSION
                }),
                $impl: {
                    nextId: 0,
                    nextHeaderBlock: 0,
                    nextBodyBlock: 0
                },
                accuracy: [],
                headerBlocks: [],
                bodyBlocks: [],
                serverIdHeaderBlockMapping: {}
            };
            console.log("Added folder " + r + " (" + g + ")"), this._folderStorages[g] = new o.FolderStorage(this, g, m, this._db, i.ActiveSyncFolderSyncer, this._LOG), 
            this._serverIdToFolderId[e] = g;
            var _ = m.$meta, b = y(this.folders, _, function(e, t) {
                return e.path.localeCompare(t.path);
            });
            return this.folders.splice(b, 0, _), c || this.universe.__notifyAddedFolder(this, _), 
            _;
        },
        _deletedFolder: function(e, t) {
            var n = this._serverIdToFolderId[e], o = this._folderInfos[n], r = o.$meta;
            console.log("Deleted folder " + r.name + " (" + n + ")"), delete this._serverIdToFolderId[e], 
            delete this._folderInfos[n], delete this._folderStorages[n];
            var s = this.folders.indexOf(r);
            this.folders.splice(s, 1), null === this._deadFolderIds && (this._deadFolderIds = []), 
            this._deadFolderIds.push(n), t || this.universe.__notifyRemovedFolder(this, r);
        },
        _recreateFolder: function(e, t) {
            this._LOG.recreateFolder(e);
            var n = this._folderInfos[e];
            n.$impl = {
                nextId: 0,
                nextHeaderBlock: 0,
                nextBodyBlock: 0
            }, n.accuracy = [], n.headerBlocks = [], n.bodyBlocks = [], n.serverIdHeaderBlockMapping = {}, 
            null === this._deadFolderIds && (this._deadFolderIds = []), this._deadFolderIds.push(e);
            var r = this;
            this.saveAccountState(null, function() {
                var s = new o.FolderStorage(r, e, n, r._db, i.ActiveSyncFolderSyncer, r._LOG);
                for (var a in Iterator(r._folderStorages[e]._slices)) {
                    var c = a[1];
                    c._storage = s, c.reset(), s.sliceOpenMostRecent(c);
                }
                r._folderStorages[e]._slices = [], r._folderStorages[e] = s, t(s);
            }, "recreateFolder");
        },
        createFolder: p(3, function(e, t, n, o) {
            var r = this, s = e ? this._folderInfos[e] : "0", i = _.FolderHierarchy.Tags, a = _.FolderHierarchy.Enums.Status, c = _.FolderHierarchy.Enums.Type.Mail, u = new g.Writer("1.3", 1, "UTF-8");
            u.stag(i.FolderCreate).tag(i.SyncKey, this.meta.syncKey).tag(i.ParentId, s).tag(i.DisplayName, t).tag(i.Type, c).etag(), 
            this.conn.postCommand(u, function(e, n) {
                r._reportErrorIfNecessary(e);
                var u, l, d = new g.EventParser();
                d.addEventListener([ i.FolderCreate, i.Status ], function(e) {
                    u = e.children[0].textContent;
                }), d.addEventListener([ i.FolderCreate, i.SyncKey ], function(e) {
                    r.meta.syncKey = e.children[0].textContent;
                }), d.addEventListener([ i.FolderCreate, i.ServerId ], function(e) {
                    l = e.children[0].textContent;
                });
                try {
                    d.run(n);
                } catch (h) {
                    return console.error("Error parsing FolderCreate response:", h, "\n", h.stack), 
                    o("unknown"), void 0;
                }
                if (u === a.Success) {
                    var p = r._addedFolder(l, s, t, c);
                    o(null, p);
                } else u === a.FolderExists ? o("already-exists") : o("unknown");
            });
        }),
        deleteFolder: p(1, function(e, t) {
            var n = this, o = this._folderInfos[e].$meta, r = _.FolderHierarchy.Tags, s = _.FolderHierarchy.Enums.Status;
            _.FolderHierarchy.Enums.Type.Mail;
            var i = new g.Writer("1.3", 1, "UTF-8");
            i.stag(r.FolderDelete).tag(r.SyncKey, this.meta.syncKey).tag(r.ServerId, o.serverId).etag(), 
            this.conn.postCommand(i, function(e, i) {
                n._reportErrorIfNecessary(e);
                var a, c = new g.EventParser();
                c.addEventListener([ r.FolderDelete, r.Status ], function(e) {
                    a = e.children[0].textContent;
                }), c.addEventListener([ r.FolderDelete, r.SyncKey ], function(e) {
                    n.meta.syncKey = e.children[0].textContent;
                });
                try {
                    c.run(i);
                } catch (u) {
                    return console.error("Error parsing FolderDelete response:", u, "\n", u.stack), 
                    t("unknown"), void 0;
                }
                a === s.Success ? (n._deletedFolder(o.serverId), t(null, o)) : t("unknown");
            });
        }),
        sendMessage: p(1, function(e, t) {
            var n = this;
            e.withMessageBlob({
                includeBcc: !0
            }, function(o) {
                if (this.conn.currentVersion.gte("14.0")) {
                    var r = _.ComposeMail.Tags, s = new g.Writer("1.3", 1, "UTF-8", null, "blob");
                    s.stag(r.SendMail).tag(r.ClientId, Date.now().toString() + "@mozgaia").tag(r.SaveInSentItems).stag(r.Mime).opaque(o).etag().etag(), 
                    this.conn.postCommand(s, function(e, o) {
                        return e ? (n._reportErrorIfNecessary(e), console.error(e), t("unknown"), void 0) : (null === o ? (console.log("Sent message successfully!"), 
                        t(null)) : (console.error("Error sending message. XML dump follows:\n" + o.dump()), 
                        t("unknown")), void 0);
                    }, null, null, function() {
                        e.renewSmartWakeLock("ActiveSync XHR Progress");
                    });
                } else this.conn.postData("SendMail", "message/rfc822", o, function(e) {
                    return e ? (n._reportErrorIfNecessary(e), console.error(e), t("unknown"), void 0) : (console.log("Sent message successfully!"), 
                    t(null), void 0);
                }, {
                    SaveInSent: "T"
                }, null, function() {
                    e.renewSmartWakeLock("ActiveSync XHR Progress");
                });
            }.bind(this));
        }),
        getFolderStorageForFolderId: function(e) {
            return this._folderStorages[e];
        },
        getFolderStorageForServerId: function(e) {
            return this._folderStorages[this._serverIdToFolderId[e]];
        },
        getFolderMetaForFolderId: function(e) {
            return this._folderInfos.hasOwnProperty(e) ? this._folderInfos[e].$meta : null;
        },
        ensureEssentialOfflineFolders: function() {
            [ {
                type: "inbox",
                displayName: "Inbox",
                typeNum: v.DefaultInbox
            }, {
                type: "outbox",
                displayName: "outbox",
                typeNum: v.Unknown
            }, {
                type: "localdrafts",
                displayName: "localdrafts",
                typeNum: v.Unknown
            } ].forEach(function(e) {
                this.getFirstFolderWithType(e.type) || this._addedFolder(null, "0", e.displayName, e.typeNum, e.type, !0);
            }, this);
        },
        ensureEssentialOnlineFolders: function(e) {
            e && e();
        },
        normalizeFolderHierarchy: n.normalizeFolderHierarchy,
        scheduleMessagePurge: function(e, t) {
            t && t();
        },
        upgradeFolderStoragesIfNeeded: n.upgradeFolderStoragesIfNeeded,
        runOp: n.runOp,
        getFirstFolderWithType: n.getFirstFolderWithType,
        getFolderByPath: n.getFolderByPath,
        saveAccountState: n.saveAccountState,
        runAfterSaves: n.runAfterSaves,
        allOperationsCompleted: function() {}
    };
    var S = h.LOGFAB = e.register(l, {
        ActiveSyncAccount: {
            type: e.ACCOUNT,
            events: {
                createFolder: {},
                deleteFolder: {},
                recreateFolder: {
                    id: !1
                },
                accountDeleted: {
                    where: !1
                }
            },
            asyncJobs: {
                runOp: {
                    mode: !0,
                    type: !0,
                    error: !1,
                    op: !1
                },
                saveAccountState: {
                    reason: !0,
                    folderSaveCount: !0
                }
            },
            errors: {
                opError: {
                    mode: !1,
                    type: !1,
                    ex: e.EXCEPTION
                }
            }
        },
        ActiveSyncConnection: {
            type: e.CONNECTION,
            events: {
                options: {
                    special: !1,
                    status: !1,
                    result: !1
                },
                command: {
                    name: !1,
                    special: !1,
                    status: !1
                }
            },
            TEST_ONLY_events: {
                options: {},
                command: {
                    params: !1,
                    extraHeaders: !1,
                    sent: !1,
                    response: !1
                }
            }
        }
    });
}), define("activesync/configurator", [ "rdcommon/log", "slog", "../accountcommon", "../a64", "./account", "../date", "tcp-socket", "require", "exports" ], function(e, t, n, o, r, s, i, a, c) {
    function u(e, t) {
        function n(e) {
            if (a) {
                var n = a;
                a = null;
                try {
                    n.close();
                } catch (o) {}
                t(e);
            }
        }
        var o = /^https:\/\/([^:\/]+)(?::(\d+))?/.exec(e);
        if (!o) return t(null), void 0;
        var r = o[2] ? parseInt(o[2], 10) : 443, s = o[1];
        console.log("checking", s, r, "for security problem");
        var a = i.open(s, r);
        a.onopen = function() {
            a.send(new TextEncoder("utf-8").encode("GET /images/logo.png HTTP/1.1\n\n"));
        }, a.onerror = function(e) {
            var t = null;
            e && "object" == typeof e && /^Security/.test(e.name) && (t = "bad-security"), n(t);
        }, a.ondata = function() {
            n(null);
        };
    }
    c.account = r, c.configurator = {
        timeout: 3e4,
        _getFullDetailsFromAutodiscover: function(e, n, o, r) {
            t.log("activesync.configurator.autodiscover:begin", {
                url: o
            }), e.raw_autodiscover(o, n.emailAddress, n.password, self.timeout, !1, function(n, s) {
                if (n) {
                    var i = "no-config-info", a = {};
                    return n instanceof e.HttpError ? 401 === n.status ? i = "bad-user-or-pass" : 403 === n.status ? i = "not-authorized" : a.status = n.status : n instanceof e.AutodiscoverDomainError && t.log("activesync.configurator.autodiscover.error", {
                        message: n.message
                    }), t.log("activesync.configurator.autodiscover:end", {
                        url: o,
                        err: i
                    }), r(i, null, a), void 0;
                }
                t.log("activesync.configurator.autodiscover:end", {
                    url: o,
                    server: s.mobileSyncServer.url
                });
                var c = {
                    type: "activesync",
                    displayName: s.user.name,
                    incoming: {
                        server: s.mobileSyncServer.url,
                        username: s.user.email
                    }
                };
                r(null, c, null);
            });
        },
        tryToCreateAccount: function(e, t, n, o, r) {
            a([ "activesync/protocol" ], function(s) {
                return n.incoming.autodiscoverEndpoint ? (this._getFullDetailsFromAutodiscover(s, t, n.incoming.autodiscoverEndpoint, function(n, i, a) {
                    return n ? (o(n, i, a), void 0) : (this._createAccountUsingFullInfo(e, t, i, o, s, r), 
                    void 0);
                }.bind(this)), void 0) : (this._createAccountUsingFullInfo(e, t, n, o, s, r), void 0);
            }.bind(this));
        },
        _createAccountUsingFullInfo: function(e, n, i, a, c) {
            t.log("activesync.configurator.create:begin", {
                server: i.incoming.server
            });
            var l = {
                username: i.incoming.username,
                password: n.password
            }, d = r.makeUniqueDeviceId(), h = this, p = new c.Connection(d);
            p.open(i.incoming.server, l.username, l.password), p.timeout = r.DEFAULT_TIMEOUT_MS, 
            p.connect(function(r) {
                if (r) {
                    var f, g = {
                        server: i.incoming.server
                    };
                    return r instanceof c.HttpError ? (401 === r.status ? f = "bad-user-or-pass" : 403 === r.status ? f = "not-authorized" : (f = "server-problem", 
                    g.status = r.status), t.log("activesync.configurator.create:end", {
                        server: i.incoming.server,
                        err: f
                    }), a(f, null, g), void 0) : (u(i.incoming.server, function(e) {
                        var t;
                        t = e ? "bad-security" : "unresponsive-server", a(t, null, g);
                    }), void 0);
                }
                var m = o.encodeInt(e.config.nextAccountNum++), _ = {
                    id: m,
                    name: n.accountName || n.emailAddress,
                    defaultPriority: s.NOW(),
                    type: "activesync",
                    syncRange: "auto",
                    syncInterval: n.syncInterval || 0,
                    notifyOnNew: n.hasOwnProperty("notifyOnNew") ? n.notifyOnNew : !0,
                    playSoundOnSend: n.hasOwnProperty("playSoundOnSend") ? n.playSoundOnSend : !0,
                    credentials: l,
                    connInfo: {
                        server: i.incoming.server,
                        deviceId: d
                    },
                    identities: [ {
                        id: m + "/" + o.encodeInt(e.config.nextIdentityNum++),
                        name: n.displayName || i.displayName,
                        address: n.emailAddress,
                        replyTo: null,
                        signature: null
                    } ]
                };
                t.log("activesync.configurator.create:end", {
                    server: i.incoming.server,
                    id: m
                }), h._loadAccount(e, _, p, function(e) {
                    a(null, e, null);
                });
            });
        },
        recreateAccount: function(e, t, s, i) {
            var a = s.def, c = {
                username: a.credentials.username,
                password: a.credentials.password
            }, u = o.encodeInt(e.config.nextAccountNum++), l = {
                id: u,
                name: a.name,
                type: "activesync",
                syncRange: a.syncRange,
                syncInterval: a.syncInterval || 0,
                notifyOnNew: a.hasOwnProperty("notifyOnNew") ? a.notifyOnNew : !0,
                playSoundOnSend: a.hasOwnProperty("playSoundOnSend") ? a.playSoundOnSend : !0,
                credentials: c,
                connInfo: {
                    server: a.connInfo.server,
                    deviceId: a.connInfo.deviceId || r.makeUniqueDeviceId()
                },
                identities: n.recreateIdentities(e, u, a.identities)
            };
            this._loadAccount(e, l, null, function(e) {
                i(null, e, null);
            });
        },
        _loadAccount: function(e, t, n, o) {
            var r = {
                $meta: {
                    nextFolderNum: 0,
                    nextMutationNum: 0,
                    lastFolderSyncAt: 0,
                    syncKey: "0"
                },
                $mutations: [],
                $mutationState: {}
            };
            e.saveAccountDef(t, r), e._loadAccount(t, r, n, o);
        }
    };
});